//Options.java

/*** 
 Questa classe visualizza una finestra che permette di impostare vari parametri relativi al 
 funzionamento e all'aspetto del programma.
 
 Autore: Alessandro Caviola
***/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

class Options extends JDialog
{
  //Pulsanti
  private JButton ok;
  private JButton cancel;
  
  private Container container;
  private Listener listener = new Listener();
  
  //Canale 1, Canale 2, protocollo  e terminatore
  public JLabel ip1;
  public JTextField ipctrl1;
  public JLabel port1;
  public JTextField portctrl1;
  public JLabel port12;
  public JTextField portctrl12;
  
  public JLabel ip2;
  public JTextField ipctrl2;
  public JLabel port2;
  public JTextField portctrl2;
  public JLabel port122;
  public JTextField portctrl22;
  
  public JLabel term;
  public List terminator;
  
  public JCheckBox ext_prot;
  
  //Primo giocatore, stepby e ignora remote
  public JLabel firsttomove;
  public ButtonGroup firstmovectrl;
  public JRadioButton player1;
  public JRadioButton player2;
  
  public JCheckBox ignorerem;
  public JCheckBox stepby;
  
  //Colore, tabellone
  public JLabel playerclr;
  public List playerc;
  public JLabel opponentclr;
  public List opponentc;
  public JLabel table;
  public List tablelist;
  
  private JPanel conn;
  private JPanel game;
  private JPanel visual;
  
  public boolean exit; //Se true, l'uscita e' avvenuta tramite OK, altrimenti tramite Cancel
  
  Options(JFrame owner)
  {
    super(owner, "Options", true);
    InitUI();
  }
  
  public void InitUI()
  {
    setBounds(100, 100, 600, 400);
    setResizable(false);
    
    container = getContentPane(); 
    container.setLayout(null);
    
    ok = new JButton("OK");
    ok.setBounds(200, 330, 80, 30);
    ok.addActionListener(listener);
    container.add(ok);
    
    cancel = new JButton("Cancel");
    cancel.setBounds(320, 330, 80, 30);
    cancel.addActionListener(listener);
    container.add(cancel);  
    
    conn = new JPanel();
    conn.setLayout(null);
    conn.setBounds(5, 5, 585, 150);
    conn.setBorder(new TitledBorder("Connection settings"));
    
    //Ch 1
    ip1 = new JLabel("Ch.1 in IP address :");
    ip1.setBounds(10, 20, 120, 20);
    conn.add(ip1);
   
    ipctrl1 = new JTextField();
    ipctrl1.setBounds(130, 20, 110, 20);
    conn.add(ipctrl1);
    
    port1 = new JLabel("Ch.1 out Port:");
    port1.setBounds(270, 20, 80, 20);
    conn.add(port1);
    
    portctrl1 = new JTextField();
    portctrl1.setBounds(360, 20, 40, 20);
    conn.add(portctrl1);
 
    port12 = new JLabel("Ch.1 in Port:");
    port12.setBounds(430, 20, 80, 20);
    conn.add(port12);
    
    portctrl12 = new JTextField();
    portctrl12.setBounds(520, 20, 40, 20);
    conn.add(portctrl12);

    
    //Ch 2
    ip2 = new JLabel("Ch.2 in IP address :");
    ip2.setBounds(10, 50, 120, 20);
    conn.add(ip2);
   
    ipctrl2 = new JTextField();
    ipctrl2.setBounds(130, 50, 110, 20);
    conn.add(ipctrl2);
    
    port2 = new JLabel("Ch.2 out Port:");
    port2.setBounds(270, 50, 80, 20);
    conn.add(port2);
    
    portctrl2 = new JTextField();
    portctrl2.setBounds(360, 50, 40, 20);
    conn.add(portctrl2);
 
    port12 = new JLabel("Ch.2 in Port:");
    port12.setBounds(430, 50, 80, 20);
    conn.add(port12);

    portctrl22 = new JTextField();
    portctrl22.setBounds(520, 50, 40, 20);
    conn.add(portctrl22);
    
    term = new JLabel("Term. character:");
    term.setBounds(10, 90, 100, 20);
    conn.add(term);
    
    terminator = new List(3, false);
    terminator.setBounds(120, 90, 50, 50);
    terminator.add(":");
    terminator.add("-");
    terminator.add("\\n");
    terminator.add("\\0");
    conn.add(terminator);
    
    ext_prot = new JCheckBox("Use ext. protocol");
    ext_prot.setBounds(230, 90, 140, 20);
    conn.add(ext_prot);
    
    
    //first pl, stepby, ignore
    game = new JPanel();
    game.setLayout(null);
    game.setBounds(5, 150, 585, 50);
    game.setBorder(new TitledBorder("Game settings"));
    
    firsttomove = new JLabel("First move:");
    firsttomove.setBounds(10, 20, 70, 20);
    game.add(firsttomove);
    firstmovectrl = new ButtonGroup();
    
    player1 = new JRadioButton("player 1");
    player1.setBounds(80, 20, 70, 20);
    firstmovectrl.add(player1);
    game.add(player1);
    
    player2 = new JRadioButton("player 2");
    player2.setBounds(160, 20, 70, 20);
    firstmovectrl.add(player2);
    game.add(player2); 
    
    stepby = new JCheckBox("Step by step");
    stepby.setBounds(270, 20, 130, 20);
    game.add(stepby);
    
    ignorerem = new JCheckBox("Ignore remote conf.");
    ignorerem.setBounds(400, 20, 150, 20);
    game.add(ignorerem);
 
    //Colori e tabellone
    visual = new JPanel();
    visual.setLayout(null);
    visual.setBounds(5, 230, 585, 90);
    visual.setBorder(new TitledBorder("Visual settings")); 
    
    playerclr = new JLabel("Player color:");
    playerclr.setBounds(10, 20, 80, 20);
    visual.add(playerclr);
    
    playerc = new List(3, false);
    playerc.add("red");
    playerc.add("blue");
    playerc.add("green");
    playerc.add("yellow");
    playerc.add("white");
    playerc.add("black");
    playerc.setBounds(100, 20, 70, 60);
    visual.add(playerc);
    
    opponentclr = new JLabel("Opponent color:");
    opponentclr.setBounds(190, 20, 90, 20);
    visual.add(opponentclr);
    
    opponentc = new List(3, false);
    opponentc.add("red");
    opponentc.add("blue");
    opponentc.add("green");
    opponentc.add("yellow");
    opponentc.add("white");
    opponentc.add("black");
    opponentc.setBounds(290, 20, 70, 60);
    visual.add(opponentc);
    
    table = new JLabel("Board:");
    table.setBounds(380, 20, 50, 20);
    visual.add(table);
    
    tablelist = new List(3, false);
    tablelist.setBounds(440, 20, 110, 60);
    tablelist.add("Madreperla");
 /*   tablelist.add("Candles");
    tablelist.add("Scacchiera");
    tablelist.add("Fantascienza");
    tablelist.add("Manhattan");*/
    visual.add(tablelist);
       
    container.add(conn);
    container.add(game);
    container.add(visual);
  }
  
  class Listener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      String command = e.getActionCommand();
      
      if(command == "OK")
      {
        exit = true;
        dispose();
      }
      
      if(command == "Cancel")
      {
        exit = false;
        dispose();
      }
    }
  }
}